Description

There are cases when you need to pass a pre-initialized buffer to

getsockopt, but ruby currently doesn't support this.

For an example, see the API used by iptables to manipulate the firewall

rulesets (below). You have to set the table name in the buffer passed to

getsockopt; the call then modifies the remainder of the buffer.

So I propose that BasicSocket#getsockopt be enhanced to allow an optional

third parameter, which is an existing String buffer, used both to pass

data and receive the result.

Does this sound reasonable?

Regards, Brian.

-------- 8< ----------------------------------------------

/* extract from iptables-1.4.4/libiptc/libiptc.c */

struct xtc_handle *

TC_INIT(const char *tablename)

{

STRUCT_GETINFO info;

socklen_t s;

int sockfd;

...

s = sizeof(info);

    strcpy(info.name, tablename);

    if (getsockopt(sockfd, TC_IPPROTO, SO_GET_INFO, &info, &s) < 0) {

            close(sockfd);

            return NULL;

    }

    DEBUGP("valid_hooks=0x%08x, num_entries=%u, size=%u\n",

            info.valid_hooks, info.num_entries, info.size);

 ...

History

#1 - 06/13/2011 04:59 PM - akr (Akira Tanaka)

I think it is reasonable.

It also makes us possible to specify the buffer size.

Currently the buffer size for getsockopt is fixed. (256 bytes)

However I'd like to see actual good example for this feature.

It is great for the method document.

I searched Linux kernel for ".getsockopt" and "copy_from_user".

I guess SCTP_STATUS or IP_MSFILTER can be a candidate.

Is there better example?
#2 - 08/07/2011 11:55 PM - kosaki (Motohiro KOSAKI)

- Status changed from Open to Feedback

#3 - 11/09/2012 06:09 PM - mame (Yusuke Endoh)

- Target version set to 2.6

#4 - 12/25/2017 06:14 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)
